extends CanvasLayer
class_name Images

@export_node_path("UltraleapHandTracking", "UltraleapDeviceNode") var tracking

var current_device : UltraleapDevice
var previous_tracking_mode : UltraleapTypes.TrackingMode = UltraleapTypes.TrackingMode.Desktop

func _ready():
	tracking = get_node(tracking)
	

func _process(_delta):
	if current_device == null:
		return
	
	if previous_tracking_mode != current_device.get_tracking_mode():
		previous_tracking_mode = current_device.get_tracking_mode()
		_update_baseline()


func current_device_changed(device):
	current_device = device
	
	$HBoxContainer/LeftSubViewportContainer/SubViewport/Hands.tracking = current_device
	$HBoxContainer/RightSubViewportContainer/SubViewport/Hands.tracking = current_device

	$HBoxContainer/LeftSubViewportContainer/SubViewport/Image/Panel.tracking = current_device
	$HBoxContainer/RightSubViewportContainer/SubViewport/Image/Panel.tracking = current_device
	
	_update_baseline()


func _update_baseline():
	if current_device == null:
		return
	
	var baseline : int = current_device.baseline
	var factor : int = 1
	
	if current_device.get_tracking_mode() != UltraleapTypes.TrackingMode.Desktop:
		factor = -1
	
	$HBoxContainer/LeftSubViewportContainer/SubViewport/Camera3D.position.x = factor * -(baseline / 2.0) / 1000000.0
	$HBoxContainer/RightSubViewportContainer/SubViewport/Camera3D.position.x = factor * (baseline / 2.0) / 1000000.0


func view_type_selected(index):
	if index == 0:
		$HBoxContainer/LeftSubViewportContainer.show()
		$HBoxContainer/RightSubViewportContainer.show()
	elif index == 1:
		$HBoxContainer/LeftSubViewportContainer.show()
		$HBoxContainer/RightSubViewportContainer.hide()
	elif index == 2:
		$HBoxContainer/LeftSubViewportContainer.hide()
		$HBoxContainer/RightSubViewportContainer.show()


func _on_images_policy_changed(state):
	if state:
		$HBoxContainer/LeftSubViewportContainer/SubViewport/Image/TextureRect.hide()
		$HBoxContainer/RightSubViewportContainer/SubViewport/Image/TextureRect.hide()
	else:
		$HBoxContainer/LeftSubViewportContainer/SubViewport/Image/TextureRect.show()
		$HBoxContainer/RightSubViewportContainer/SubViewport/Image/TextureRect.show()
