#ifndef ULTRALEAP_IMAGE_H
#define ULTRALEAP_IMAGE_H

#include <godot_cpp/classes/global_constants.hpp>
#include <godot_cpp/classes/ref.hpp>
#include <godot_cpp/classes/resource.hpp>
#include <godot_cpp/classes/packed_data_container.hpp>

#include <godot_cpp/core/binder_common.hpp>
#include <godot_cpp/core/class_db.hpp>

#include <LeapC.h>

using namespace godot;

class UltraleapImage : public Resource {
    GDCLASS(UltraleapImage, Resource);

public:
    PackedByteArray data = PackedByteArray();
    PackedVector2Array distortion_matrix = PackedVector2Array();
    Vector2i size = Vector2i();

    // Getters / Setters

    PackedByteArray get_data() { return data; }
    PackedVector2Array get_distortion_matrix() { return distortion_matrix; }
    uint64_t get_matrix_version() { return matrix_version; }
    Vector2i get_size() { return size; }

    static void fill_images_data(Ref<UltraleapImage> left, Ref<UltraleapImage> right, const LEAP_IMAGE* images);

    uint64_t matrix_version = 999;

protected:
    static void _bind_methods();
};

#endif